"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var util = require("util");
var readline = require("readline");
var _ = require("lodash");
var i18next = require("i18next");
var Backend = require("i18next-node-fs-backend");
var stream_buffers_1 = require("stream-buffers");
var source_map_1 = require("source-map");
var VirtualModulePlugin = require('virtual-module-webpack-plugin');
var readFile = util.promisify(fs.readFile);
var unlink = util.promisify(fs.unlink);
var stat = util.promisify(fs.stat);
var mkdir = util.promisify(fs.mkdir);
function exists(path) {
    return __awaiter(this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, stat(path)];
                case 1:
                    _a.sent();
                    return [2 /*return*/, true];
                case 2:
                    e_1 = _a.sent();
                    if (e_1.code === 'ENOENT') {
                        return [2 /*return*/, false];
                    }
                    throw e_1;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function extractArgs(arg, warning) {
    switch (arg.type) {
        case 'Literal':
            return arg.value;
        case 'Identifier':
            return arg.name;
        case 'ObjectExpression':
            var res = {};
            for (var i in arg.properties) {
                res[extractArgs(arg.properties[i].key)] = extractArgs(arg.properties[i].value);
            }
            return res;
        default:
            if (warning) {
                warning(arg);
            }
            return null;
    }
}
var DummySourceMapConsumer = /** @class */ (function () {
    function DummySourceMapConsumer(module) {
        this.file = module.resource;
        this.sourceRoot = module.resource;
        this.sources = [this.file];
        this.sourcesContent = [module._source._value];
    }
    DummySourceMapConsumer.prototype.computeColumnSpans = function () { };
    DummySourceMapConsumer.prototype.originalPositionFor = function (generatedPosition) {
        return _.assign({
            source: this.file,
            name: null
        }, generatedPosition);
    };
    DummySourceMapConsumer.prototype.generatedPositionFor = function (originalPosition) {
        return _.assign({
            lastColumn: originalPosition.column
        }, originalPosition);
    };
    DummySourceMapConsumer.prototype.allGeneratedPositionsFor = function (originalPosition) {
        return [this.generatedPositionFor(originalPosition)];
    };
    DummySourceMapConsumer.prototype.hasContentsOfAllSources = function () { return true; };
    DummySourceMapConsumer.prototype.sourceContentFor = function (source, returnNullOnMissing) {
        var index = this.sources.indexOf(source);
        if (index === -1) {
            if (returnNullOnMissing) {
                return null;
            }
            else {
                throw new Error("never");
            }
        }
        return this.sourcesContent[index];
    };
    DummySourceMapConsumer.prototype.eachMapping = function () {
    };
    return DummySourceMapConsumer;
}());
function getPath(template, language, namespace) {
    if (language !== undefined) {
        template = template.replace("{{lng}}", language);
    }
    if (namespace !== undefined) {
        template = template.replace("{{ns}}", namespace);
    }
    return template;
}
function removeMap(obj, keys) {
    for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
        var emptyKey = keys_1[_i];
        if (emptyKey !== undefined) {
            delete obj[emptyKey];
        }
    }
    return obj;
}
var I18nextPlugin = /** @class */ (function () {
    function I18nextPlugin(option) {
        this.missingKeys = {};
        this.startTime = Date.now();
        this.prevTimestamps = {};
        this.sourceMaps = {};
        this.missingDirInitialized = false;
        this.option = _.defaults(option, {
            functionName: "__",
            defaultNamespace: "translation",
            namespaces: [option.defaultNamespace || "translation"],
            outPath: option.resourcePath
        });
        i18next.use(Backend);
    }
    I18nextPlugin.prototype.apply = function (compiler) {
        var _this = this;
        // provide config via virtual module plugin
        compiler.apply(new VirtualModulePlugin({
            moduleName: path.join(__dirname, "config.js"),
            contents: "exports = module.exports = {\n                __esModule: true,\n                RESOURCE_PATH: \"" + this.option.outPath + "\",\n                LANGUAGES: " + JSON.stringify(this.option.languages) + ",\n                DEFAULT_NAMESPACE: \"" + this.option.defaultNamespace + "\"\n};"
        }));
        i18next.init({
            preload: this.option.languages,
            ns: this.option.namespaces,
            fallbackLng: false,
            defaultNS: this.option.defaultNamespace,
            saveMissing: true,
            missingKeyHandler: this.onKeyMissing.bind(this),
            backend: {
                loadPath: this.option.resourcePath
            }
        });
        this.context = compiler.options.context || "";
        this.initMissingDir();
        compiler.plugin("compilation", function (compilation, data) {
            // reset for new compliation
            i18next.reloadResources(_this.option.languages);
            _this.compilation = compilation;
            var changedFiles = _.keys(compilation.fileTimestamps).filter(function (watchfile) { return (_this.prevTimestamps[watchfile] || _this.startTime) < (compilation.fileTimestamps[watchfile] || Infinity); });
            for (var _i = 0, changedFiles_1 = changedFiles; _i < changedFiles_1.length; _i++) {
                var changed = changedFiles_1[_i];
                delete _this.sourceMaps[changed];
            }
            removeMap(_this.missingKeys, _.map(_this.missingKeys, function (namespaces, lng) {
                return _.isEmpty(removeMap(namespaces, _.map(namespaces, function (values, ns) {
                    return _.isEmpty(removeMap(values, _.map(values, function (deps, key) {
                        for (var _i = 0, changedFiles_2 = changedFiles; _i < changedFiles_2.length; _i++) {
                            var changed = changedFiles_2[_i];
                            delete deps[changed];
                        }
                        return _.isEmpty(deps) ? key : undefined;
                    }))) ? ns : undefined;
                }))) ? lng : undefined;
            }));
            data.normalModuleFactory.plugin("parser", function (parser) {
                var that = _this;
                parser.plugin("call " + _this.option.functionName, function (arg) {
                    return I18nextPlugin.onTranslateFunctionCall.call(this, that, arg);
                });
            });
        });
        compiler.plugin("emit", this.onEmit.bind(this));
        compiler.plugin("after-emit", this.onAfterEmit.bind(this));
    };
    I18nextPlugin.prototype.initMissingDir = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var template;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.missingDirInitialized) {
                            return [2 /*return*/];
                        }
                        template = path.resolve(this.context, this.option.pathToSaveMissing);
                        return [4 /*yield*/, Promise.all(this.option.namespaces.map(function (ns) { return _this.option.languages.map(function (lng) { return __awaiter(_this, void 0, void 0, function () {
                                var dirPath;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            dirPath = path.dirname(getPath(template, lng, ns));
                                            return [4 /*yield*/, exists(dirPath)];
                                        case 1:
                                            if (!!(_a.sent())) return [3 /*break*/, 3];
                                            return [4 /*yield*/, mkdir(dirPath)];
                                        case 2:
                                            _a.sent();
                                            _a.label = 3;
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            }); }); }))];
                    case 1:
                        _a.sent();
                        this.missingDirInitialized = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    I18nextPlugin.prototype.onEmit = function (compilation, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // emit translation files
                        this.prevTimestamps = compilation.fileTimestamps;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, Promise.all(_.flatten(_.map(this.option.languages, function (lng) { return __awaiter(_this, void 0, void 0, function () {
                                var _this = this;
                                var resourceTemplate, resourceDir;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            resourceTemplate = path.resolve(this.context, getPath(this.option.resourcePath, lng));
                                            resourceDir = path.dirname(resourceTemplate);
                                            return [4 /*yield*/, exists(resourceDir)];
                                        case 1:
                                            if (!(_a.sent())) {
                                                compilation.missingDependencies.push(resourceDir);
                                                return [2 /*return*/, []];
                                            }
                                            return [2 /*return*/, Promise.all(_.map(this.option.namespaces, function (ns) { return __awaiter(_this, void 0, void 0, function () {
                                                    var resourcePath, outPath, v_1, e_3;
                                                    return __generator(this, function (_a) {
                                                        switch (_a.label) {
                                                            case 0:
                                                                resourcePath = getPath(resourceTemplate, undefined, ns);
                                                                outPath = getPath(this.outPath, lng, ns);
                                                                _a.label = 1;
                                                            case 1:
                                                                _a.trys.push([1, 3, , 4]);
                                                                return [4 /*yield*/, readFile(resourcePath)];
                                                            case 2:
                                                                v_1 = _a.sent();
                                                                compilation.assets[outPath] = {
                                                                    size: function () { return v_1.length; },
                                                                    source: function () { return v_1; }
                                                                };
                                                                compilation.fileDependencies.push(path.resolve(resourcePath));
                                                                return [3 /*break*/, 4];
                                                            case 3:
                                                                e_3 = _a.sent();
                                                                compilation.missingDependencies.push(resourcePath);
                                                                compilation.warnings.push("Can't emit " + outPath + ". It looks like " + resourcePath + " is not exists.");
                                                                return [3 /*break*/, 4];
                                                            case 4: return [2 /*return*/];
                                                        }
                                                    });
                                                }); }))];
                                    }
                                });
                            }); })))];
                    case 2:
                        _a.sent();
                        callback();
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        callback(e_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(I18nextPlugin.prototype, "outPath", {
        get: function () {
            if (path.isAbsolute(this.option.outPath)) {
                return path.relative(this.context, this.option.outPath);
            }
            return this.option.outPath;
        },
        enumerable: true,
        configurable: true
    });
    I18nextPlugin.prototype.onAfterEmit = function (compilation, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var remains, e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        remains = _.fromPairs(_.map(this.option.languages, function (lng) { return [
                            lng,
                            _.fromPairs(_.map(_this.option.namespaces, function (ns) { return [ns, null]; }))
                        ]; }));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        // write missing
                        return [4 /*yield*/, this.initMissingDir()];
                    case 2:
                        // write missing
                        _a.sent();
                        return [4 /*yield*/, Promise.all(_.map(this.missingKeys, function (namespaces, lng) { return __awaiter(_this, void 0, void 0, function () {
                                var _this = this;
                                var resourceTemplate, resourceDir, e_5;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            resourceTemplate = path.resolve(this.context, getPath(this.option.pathToSaveMissing, lng));
                                            resourceDir = path.dirname(resourceTemplate);
                                            _a.label = 1;
                                        case 1:
                                            _a.trys.push([1, 3, , 4]);
                                            return [4 /*yield*/, mkdir(resourceDir)];
                                        case 2:
                                            _a.sent();
                                            return [3 /*break*/, 4];
                                        case 3:
                                            e_5 = _a.sent();
                                            if (e_5.code !== 'EEXIST') {
                                                throw e_5;
                                            }
                                            return [3 /*break*/, 4];
                                        case 4: return [4 /*yield*/, Promise.all(_.map(namespaces, function (values, ns) { return new Promise(function (resolve) {
                                                delete remains[lng][ns];
                                                var missingPath = getPath(resourceTemplate, undefined, ns);
                                                var stream = fs.createWriteStream(missingPath, {
                                                    encoding: "utf-8"
                                                });
                                                var keys = _.sortedUniq(_.sortBy(_.keys(values)));
                                                stream.write("{\n");
                                                stream.write(_.map(keys, function (key) { return "\t\"" + key + "\": [\n" + _.map(values[key], function (pos, module) { return "\t\t\"" + _.trim(JSON.stringify(path.relative(_this.context, module)), '"') + "(" + pos + ")\""; }).join(",\n") + "\n\t]"; }).join(",\n"));
                                                stream.end("\n}");
                                                stream.on("close", function () { return resolve(); });
                                                compilation.warnings.push("missing translation " + _.size(values) + " keys in " + lng + "/" + ns);
                                            }); }))];
                                        case 5: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }))];
                    case 3:
                        _a.sent();
                        // remove previous missings
                        return [4 /*yield*/, Promise.all(_.map(remains, function (namespaces, lng) {
                                return Promise.all(_.map(namespaces, function (__, ns) { return __awaiter(_this, void 0, void 0, function () {
                                    var missingPath;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                missingPath = path.resolve(this.context, getPath(this.option.pathToSaveMissing, lng, ns));
                                                return [4 /*yield*/, exists(missingPath)];
                                            case 1:
                                                if (!_a.sent()) return [3 /*break*/, 3];
                                                return [4 /*yield*/, unlink(missingPath)];
                                            case 2:
                                                _a.sent();
                                                _a.label = 3;
                                            case 3: return [2 /*return*/];
                                        }
                                    });
                                }); }));
                            }))];
                    case 4:
                        // remove previous missings
                        _a.sent();
                        callback();
                        return [3 /*break*/, 6];
                    case 5:
                        e_4 = _a.sent();
                        callback(e_4);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    I18nextPlugin.prototype.argsToSource = function (sourceMap, arg) {
        var beginPos = sourceMap.originalPositionFor(arg.loc.start);
        var endPos = sourceMap.originalPositionFor(arg.loc.end);
        if (beginPos.source !== null) {
            var originalSource = sourceMap.sourceContentFor(beginPos.source);
            var sourceLines_1 = [];
            if (originalSource !== null) {
                var buffer_1 = new stream_buffers_1.ReadableStreamBuffer();
                buffer_1.put(originalSource);
                buffer_1.put("\n");
                var lineIdx_1 = 0;
                return new Promise(function (resolve) {
                    var lineInterface = readline.createInterface(buffer_1).on("line", function (line) {
                        lineIdx_1++;
                        var beginCol = 0, endCol = line.length;
                        if (lineIdx_1 === beginPos.line) {
                            beginCol = beginPos.column;
                        }
                        if (lineIdx_1 === endPos.line) {
                            endCol = endPos.column;
                        }
                        if (lineIdx_1 >= beginPos.line && lineIdx_1 <= endPos.line) {
                            sourceLines_1.push(line.substring(beginCol, endCol));
                        }
                        if (lineIdx_1 === endPos.line) {
                            lineInterface.close();
                        }
                    }).on("close", function () {
                        resolve(sourceLines_1.join("\n"));
                    });
                });
            }
        }
        return Promise.resolve(null);
    };
    I18nextPlugin.onTranslateFunctionCall = function (plugin, expr) {
        var resource = this.state.current.resource;
        if (plugin.sourceMaps[resource] === undefined && this.state.current._source._sourceMap !== undefined) {
            plugin.sourceMaps[resource] = new source_map_1.SourceMapConsumer(this.state.current._source._sourceMap);
        }
        else {
            plugin.sourceMaps[resource] = new DummySourceMapConsumer(this.state.current);
        }
        var sourceMap = plugin.sourceMaps[resource];
        var args = expr.arguments.map(function (arg) { return extractArgs(arg, function (arg) { return plugin.argsToSource(sourceMap, arg).then(function (originalSource) {
            var beginPos = sourceMap.originalPositionFor(arg.loc.start);
            if (originalSource !== null) {
                plugin.warningOnCompilation("unable to parse arg " + originalSource + " at " + resource + ":(" + beginPos.line + ", " + beginPos.column + ")");
            }
            else {
                plugin.warningOnCompilation("unable to parse node at " + resource + ":(" + beginPos.line + ", " + beginPos.column + ")");
            }
        }); }); });
        var startPos = sourceMap !== undefined ? sourceMap.originalPositionFor(expr.loc.start) : expr.loc.start;
        var pos = [resource, startPos.line, startPos.column];
        for (var _i = 0, _a = plugin.option.languages; _i < _a.length; _i++) {
            var lng = _a[_i];
            var keyOrKeys = args[0];
            var option = Object.assign(_.defaults(args[1], {}), {
                lng: lng,
                defaultValue: pos
            });
            i18next.t(keyOrKeys, option);
        }
    };
    I18nextPlugin.prototype.onKeyMissing = function (lng, ns, key, pos) {
        var p = [lng, ns, key, pos[0]];
        var arr = _.get(this.missingKeys, p);
        if (arr === undefined) {
            _.set(this.missingKeys, p, []);
            arr = _.get(this.missingKeys, p);
        }
        arr.push([pos[1], pos[2]]);
    };
    I18nextPlugin.prototype.warningOnCompilation = function (msg) {
        if (this.compilation) {
            this.compilation.warnings.push(msg);
        }
    };
    return I18nextPlugin;
}());
exports.default = I18nextPlugin;
//# sourceMappingURL=index.js.map